###-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#
##  PictureEditCtrl                 #
#   -> picture-edit-view           ##
#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-###
angular.module("DocCheckPictures.controllers").controller('PictureEditCtrl', 
(
  $scope,  
  $ionicViewService, 
  $translate, 
  $cacheFactory,
  Popup, 
  Loading, 
  Pictures,
  UserPictures,    
  Settings
) ->
  
  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Service-link functions & state transitions
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Scope functions
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  # add a tag to the tag list
  $scope.addTag = ->
    isIn = false
    newTag = $scope.form.tag.trim()
    if newTag != ""
      i = 0
      while i < $scope.form.tags.length
        if($scope.form.tags[i] == newTag)
          isIn = true
        i++
      if !isIn
        $scope.form.tags.push(newTag)
      $scope.form.tag = ''    

  # remove a tag from the list
  $scope.removeTag = (tag) ->
    i = 0
    while i < $scope.form.tags.length
      if($scope.form.tags[i] == tag)
        $scope.form.tags.splice(i, 1);
      i++

  # submit changes made in form to the server
  $scope.submitEdit = ->
    if !Loading.inProgress()      
      $scope.showTabsPartly()
      pictureObj = {
        'id' : $scope.currentPicture.id
        'title' : $scope.form.title,
        'description' : $scope.form.desc,
        'visibility' : $scope.form.visibility
        'tags' : $scope.form.tags
        'language' : Settings.getLanguage()
      }
      $scope.dot.submitting = true
      Loading.start()
      UserPictures.update(pictureObj).
        success((response) ->          
          $scope.showTabs()
          Loading.stop()
          Popup.show(
            $scope.translations.EDIT_CHANGES_SUCCESS_HEADING, $scope.translations.EDIT_CHANGES_SUCCESS_CONTENT, 2000,
            -> 
              $ionicViewService.getBackView().go()
          )          
        ).
        error((error) ->
          $scope.showTabs()
          Loading.stop()
          $scope.dot.submitting = false
          Popup.show($scope.translations.EDIT_CHANGES_FAILURE_HEADING, $scope.translations.EDIT_CHANGES_FAILURE_CONTENT
          )          
        )
      $cacheFactory.get("PictureDetailCache").removeAll()

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # UI
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Init
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.init = ->    
    $scope.currentPicture = Pictures.getCurrentPicture()
    $scope.hideTabs()
    
    # init the form with the current picture information
    $scope.form = {
      'title' : $scope.currentPicture.title, 
      'desc' : $scope.currentPicture.description, 
      'visibility' : $scope.currentPicture.visibility
      'tags' : $scope.currentPicture.tags
    }

    $scope.dot = {'submitting' : false}

    $scope.$on('$destroy', ->
      $scope.showTabs()
    )

    # load the translations needed for this controller
    $translate([
               'EDIT_CHANGES_SUCCESS_HEADING'
               'EDIT_CHANGES_SUCCESS_CONTENT'
               'EDIT_CHANGES_FAILURE_HEADING'
               'EDIT_CHANGES_FAILURE_CONTENT'
               ])
    .then((translations) -> 
      $scope.translations = translations
    )
  $scope.init()  
  
)