angular.module("DocCheckPictures.controllers").controller('PrivacyCtrl', 
(
	$scope,
	$translate, 
	$timeout,
	Loading, 
	LocalStorage
) ->

	### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
	# Service-link functions & state transitions
	# -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

	$scope.setPrivacyOption = ->
		LocalStorage.set('privacySetting', $scope.privacyOptions.indexOf($scope.settings.currentPSetting))

	$scope.setCCOption = ->
		LocalStorage.set('ccSetting', $scope.ccOptions.indexOf($scope.settings.currentCCSetting))

	### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
	# Scope functions
	# -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

	$scope.setRightsOption = ->
		index = $scope.rightsOptions.indexOf($scope.settings.currentRSetting)
		LocalStorage.set('rightsSetting', index)
		$timeout(->
			$scope.show.ccOptions = (index == 1)
		, 100)	# Fix for Android. The ng-if on the Creative Commons select might interrupt
						# the $apply progress so that the selection of the Rights select isn't updated.

	### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
	# UI
	# -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

	### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
	# Init
	# -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

	$scope.init = ->
		$scope.hideTabs()
		$scope.$on('$destroy', ->
		  $scope.showTabs()
		)
		
		$scope.settings = 
		{
			'currentPrivacySetting' : LocalStorage.get('privacySetting')
			'currentRightsSetting' 	: LocalStorage.get('rightsSetting')
			'currentCCSetting'	 		: LocalStorage.get('ccSetting')
		}
		$scope.show = 
		{
			'ccOptions' : (parseInt($scope.settings.currentRightsSetting) == 1)
		}
		console.log($scope.settings.currentRightsSetting)
		console.log($scope.settings.currentRightsSetting == 1)
		console.log($scope.show.ccOptions)
		
		# Translations
		$translate([
		           'EDIT_VISIBILITY_PRIVATE',
		           'EDIT_VISIBILITY_PUBLIC',
		           'EDIT_VISIBILITY_DCMEMBER',
		           'EDIT_VISIBILITY_MEDIC'
		           'PRIVACY_ALL_RIGHTS_RESERVED'
		           'PRIVACY_CREATIVE_COMMONS'
		           'PRIVACY_CC_ATTR'
		           'PRIVACY_CC_ATTR_NODER'
		           'PRIVACY_CC_ATTR_SHARE'
		           'PRIVACY_CC_ATTR_NONCOMM'
		           'PRIVACY_CC_ATTR_NONCOMM_NODER'
		           'PRIVACY_CC_ATTR_NONCOMM_SHARE'
		           'PRIVACY_PUBLIC_DOMAIN'
		           ])
		.then((translations) -> 
			$scope.translations = translations
			$scope.privacyOptions = 	
			[
				translations.EDIT_VISIBILITY_PRIVATE 
			 	translations.EDIT_VISIBILITY_PUBLIC
			 	translations.EDIT_VISIBILITY_DCMEMBER
			 	translations.EDIT_VISIBILITY_MEDIC
			]
			$scope.rightsOptions =
			[
				translations.PRIVACY_ALL_RIGHTS_RESERVED
				translations.PRIVACY_CREATIVE_COMMONS
				translations.PRIVACY_PUBLIC_DOMAIN
			]    
			$scope.ccOptions = 
			[
				translations.PRIVACY_CC_ATTR
				translations.PRIVACY_CC_ATTR_NODER
				translations.PRIVACY_CC_ATTR_SHARE
				translations.PRIVACY_CC_ATTR_NONCOMM
				translations.PRIVACY_CC_ATTR_NONCOMM_NODER
				translations.PRIVACY_CC_ATTR_NONCOMM_SHARE
			]
			$scope.settings.currentPSetting = $scope.privacyOptions[$scope.settings.currentPrivacySetting]
			$scope.settings.currentRSetting = $scope.rightsOptions[$scope.settings.currentRightsSetting]
			$scope.settings.currentCCSetting = $scope.ccOptions[$scope.settings.currentCCSetting]
		)

	$scope.init()
)