###-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#
##  PictureSearchCtrl               #
#   -> picture-search-view         ##
#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-###
angular.module("DocCheckPictures.controllers").controller('PromotionCtrl', 
(
  $scope, 
  $state, 
  $ionicScrollDelegate, 
  Loading, 
  $http, 
  Network, 
  Pictures, 
  Camera, 
  LocalStorage, 
  Login
) ->

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Service-link functions & state transitions
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.openLink = (link) ->
    window.open(link, "_system", "location=no")

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Scope functions
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # UI
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.setDimensions = (update) ->
    # -> columns
    columns = Math.floor(window.innerWidth / $scope.pictures.minPictureDim)    
    if (columns > $scope.pictures.maxColumns)
      columns = $scope.pictures.maxColumns
    # -> container dimensions
    $scope.pictures.containerDim = window.innerWidth / columns;
    # -> rows for settings photos per page (preloading)
    rows = Math.round(window.innerHeight / $scope.pictures.containerDim)
    $scope.intPhotosPerPage = rows * columns
    # -> picture dimensions
    if($scope.pictures.containerDim > $scope.pictures.maxPictureDim)
      $scope.pictures.picturesDim = $scope.pictures.maxPictureDim
    else
      $scope.pictures.picturesDim = Math.round($scope.pictures.containerDim * 0.9)
    # -> picture margins (centering in container)
    $scope.pictures.picturesMargin = ($scope.pictures.containerDim - $scope.pictures.picturesDim) / 2   
    # -> apply
    if !$scope.$$phase
      $scope.$apply()

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Init
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.init = ->
    $scope.hideTabs()
    $scope.$on('$destroy', ->
      $scope.showTabs()
    )

    $scope.pictures = {
      'maxColumns' : 5, #constant
      'minPictureDim' : 100, #constant
      'maxPictureDim' : 220, #constant
      'picturesMargin' : 0,
      'containerPadding' : 0,
      'containerDim' : 0, 
      'picturesDim' : 0
    }
    
    angular.element(window).bind('resize', ->
      $scope.setDimensions(true)
    ) 

    $scope.setDimensions()

  $scope.init() 
)