###-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#
##  SettingsCtrl                    #
#   -> settings-view               ##
#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-###
angular.module("DocCheckPictures.controllers").controller('SettingsCtrl', 
( 
  $scope,  
  $translate, 
  Login,   
  Settings,
  Search,
  Popup,
  UpdateTimer,
  Network
) ->

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Service-link functions & state transitions
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.isAuthenticated = ->
    return Login.isAuthenticated()

  $scope.didLoginFail = ->
    return Login.didLoginFail()

  $scope.submitLogout = ->
    Login.logout({})

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Scope functions
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.load = ->
    iframe = angular.element(document.getElementById("loginFrameSettings"))      
    if(iframe[0] != undefined)
      iframe[0].addEventListener('onbeforeunload', ->
      )
      iframe[0].addEventListener('onunload', ->
      )
      iframe[0].addEventListener('onload', ->
      )

  $scope.setLanguage = ->
    language = $scope.settings.language.toLowerCase() + "_" + $scope.settings.language
    console.log(language)
    $translate.use(language)
    if Settings.setLanguage(language)
      Search.clearCaches()

    $scope.updateTranslations()

    $scope.refreshLoginFrame()    

    $translate(['UPDATE'])
    .then((translations) -> 
      UpdateTimer.setText(translations.UPDATE)
    )

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # UI
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  ionic.DomUtil.ready($scope.load)

  ### -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/
  # Init
  # -/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/ ### 

  $scope.init = ->
    $scope.login = {
      'noConnection' : !Network.isConnected()
    }
    #Login.setLoginFailed(false)  	
    #$scope.loginUrl = "https://login.doccheck.com/code/"+Settings.getLanguage()+"/2000000006987/s_mobile/response_type=token/_self?dc_force_logout=1"
    $scope.languages = ['DE', 'EN'] #, 'FR', 'ES', 'IT', 'NL']    
    $scope.settings = {currentLanguage : $scope.languages.indexOf(Settings.getLanguage().toUpperCase()), 'subview':false}

  $scope.init()

)
