angular.module("DocCheckPictures.services").factory "Search", ($base64, $http, $rootScope, $cacheFactory, Login, LocalStorage, Network, Settings) ->

  ###
  # Manual caching of search results
  ###

  cache = {
            "searchCache" : {}, 
            "ownCache" : {},
            "homeCache" : {}
          }

  clearCaches: ->
    cache = {
            "searchCache" : {}, 
            "ownCache" : {},
            "homeCache" : {}
          }    
    if $cacheFactory.get('PictureCache')
      $cacheFactory.get('PictureCache').removeAll()

  setCache: (location="searchCache", page=0, items=[], totalResults=0) ->
    cache[location].page = page
    cache[location].items = items
    if location == "searchCache" 
      cache[location].totalResults = totalResults   
      if !cache[location].lastSearchPattern
        cache[location].lastSearchPattern = ""

  setLastSearchPattern: (pattern="") ->
    if pattern != "search.more"
      cache["searchCache"].lastSearchPattern = pattern
      cache["searchCache"].page = 0  
      cache["searchCache"].items = []
      cache["searchCache"].totalResults = 0

  getLastSearchPattern: ->
    return cache['searchCache'].lastSearchPattern

  getCache: (location="searchCache") ->
    return cache[location]

  getPicturesByQuery: (searchQuery="", upage=1, intPhotosPerPage=20, excellent=0, cache) ->
    qUrl = Network.getPhotoApiUrl()
    qParams = {
      page: upage
      epp: (intPhotosPerPage*2)
      term: searchQuery
      dc_api_key: Network.getApiKey()
      language: Settings.getLanguage()
      excellent_flag: excellent
    }

    return $http({
      url: qUrl
      method: 'GET'
      cache: $cacheFactory.get('PictureCache')
      timeout: 10000
      transformRequest: (obj) =>
        str = []
        for p of obj
          str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
        return str.join("&")
      params: qParams
    })

  getPictureDetailByQuery: (id, pCache=false) ->
    qUrl = Network.getPhotoApiUrl() + "/" + id
    qParams = {
      dc_api_key: Network.getApiKey()
      language: Settings.getLanguage()
    }
    return $http({
      url: qUrl
      method: 'GET'
      cache: pCache
      timeout: 10000
      params: qParams
      })

  getUserPictures: (upage=1, intPhotosPerPage=20) ->
    qUrl = Network.getChannelUrl()
    qParams = {
      page: upage
      epp: intPhotosPerPage
      dc_api_key: Network.getApiKey()
      language: Settings.getLanguage()
    }
    return $http({
      url: qUrl,
      method: 'GET'
      cache: false
      timeout: 10000
      transformRequest: (obj) =>
        str = []
        for p of obj
          str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
        return str.join("&")
      params: qParams
    })