angular.module("DocCheckPictures.services").factory "UserPictures", ($base64, $http, $rootScope, $cacheFactory, Login, LocalStorage, Network, Settings) ->

  upload: (imageData, startedCallback=undefined, finishedCallback=undefined, progressCallback=undefined, errorCallback=undefined) ->
    
    uploadFile = (file) ->

      qUrl = Network.getPhotoApiUrl()
      qData = {
        Filedata: file
        language: Settings.getLanguage()
      }
      
      createFileName = -> 
        d = new Date()
        return ("" + d.getFullYear() + "-" + (d.getMonth()+1) + "-" + d.getDate() + "-" + d.getHours() + "-" + d.getMinutes() + "-" + d.getSeconds() + "-DcApp.jpeg")

      fd = new FormData()
      fd.append('Filedata', file, createFileName())
      fd.append('language', Settings.getLanguage())
      fd.append('visibility', LocalStorage.get('privacySetting'))
      
      xhr = new XMLHttpRequest()

      xhr.upload.addEventListener('progress', (e) ->
        if progressCallback
          progressCallback(e)
      , false)
      xhr.addEventListener("load", (e) ->
        if finishedCallback
          finishedCallback(e)
      , false)
      xhr.addEventListener("error", (e) ->
        if errorCallback
          errorCallback(e)
      , false)
      xhr.addEventListener("abort", (e) ->
        if errorCallback
          errorCallback(e)
      , false)

      xhr.open('POST', qUrl)

      xhr.setRequestHeader('Cache-Control', 'no-cache')
      xhr.setRequestHeader('Authorization', Login.getToken())
      xhr.setRequestHeader('dc_api_key', Network.getApiKey())

      if startedCallback
        startedCallback()        
      xhr.send(fd)      
      
    createBlob = (base64str) ->     
      binary = atob(base64str.replace(/\s/g, ''))
      len = binary.length
      buffer = new ArrayBuffer(len)
      view = new Uint8Array(buffer)
      i = 0
      while i < len
        view[i] = binary.charCodeAt(i)
        i++       
      blob = new Blob( [view], { type: "image/jpeg" })
      return blob

    uploadFile(createBlob(imageData))


  delete: (id) ->
    qUrl = Network.getPhotoApiUrl() + "/" + id
    qParams = {
      dc_api_key: Network.getApiKey()
    }

    return $http({
      url: qUrl,
      method: 'DELETE',
      params: qParams
    })

  update: (pictureObj) ->
    qUrl = Network.getPhotoApiUrl() + "/" + pictureObj.id
    qParams = {
      'language': Settings.getLanguage()
      'title': pictureObj.title
      'visibility': pictureObj.visibility
      'description': pictureObj.description
      'tags[]': pictureObj.tags
      'dc_api_key': Network.getApiKey()
    }

    return $http({
      url: qUrl,
      method: 'PUT',
      params: qParams
    })
  


